import datetime
from sqlalchemy.orm import joinedload_all
from sqlalchemy.sql.expression import func
import uuid

from pyramid.view import view_config

from brewman.models import DBSession
from brewman.models.master import LedgerBase
from brewman.models.validation_exception import TryCatchFunction

from brewman.models.voucher import Voucher, Journal, VoucherType
from brewman.views.services.session import session_period_start, session_period_finish
from brewman.views.services.voucher import get_edit_url


@view_config(request_method='GET', route_name='ledger_id', renderer='brewman:templates/angular_base.mako',
             permission='Ledger')
@view_config(request_method='GET', route_name='ledger', renderer='brewman:templates/angular_base.mako',
             permission='Ledger')
def html(request):
    return {}


@view_config(request_method='GET', route_name='api_ledger', renderer='json', permission='Ledger')
def show_blank(request):
    return {'StartDate': session_period_start(request),
            'FinishDate': session_period_finish(request), 'Ledger': None, 'Body': [], 'Footer': {}}


@view_config(request_method='GET', route_name='api_ledger_id', renderer='json', permission='Ledger')
@TryCatchFunction
def show_data(request):
    id = request.matchdict['id']
    ledger = LedgerBase.by_id(uuid.UUID(id))
    start_date = request.GET.get('StartDate', session_period_start(request))
    finish_date = request.GET.get('FinishDate', session_period_finish(request))
    info = {'StartDate': start_date, 'FinishDate': finish_date,
            'Ledger': {'LedgerID': ledger.id, 'Name': ledger.name},
            'Body': [], 'Footer': {}}
    build_report(request, info)
    return info


def build_report(request, info):
    ledger_id = info['Ledger']['LedgerID']
    start_date = info['StartDate']
    finish_date = info['FinishDate']
    total_debit, total_credit, running_total, opening = opening_balance(ledger_id, start_date)
    info['Body'].append(opening)

    query = Voucher.query().options(joinedload_all(Voucher.journals, Journal.ledger, innerjoin=True)) \
        .filter(Voucher.journals.any(Journal.ledger_id == ledger_id)) \
        .filter(Voucher.date >= datetime.datetime.strptime(start_date, '%d-%b-%Y')) \
        .filter(Voucher.date <= datetime.datetime.strptime(finish_date, '%d-%b-%Y')) \
        .filter(Voucher.type != VoucherType.by_name('Issue').id) \
        .order_by(Voucher.date).order_by(Voucher.last_edit_date).all()

    for voucher in query:
        debit = 0
        credit = 0
        journal_debit = 0
        name = ""
        for journal in voucher.journals:
            if journal.ledger_id == ledger_id:
                if voucher.posted:
                    running_total += (journal.amount * journal.debit)
                journal_debit = journal.debit
                if journal.debit == 1:
                    debit = journal.amount
                    total_debit += journal.amount
                    credit = ""
                else:
                    credit = journal.amount
                    total_credit += journal.amount
                    debit = ""
        for journal in voucher.journals:
            if journal.debit != journal_debit:
                name += "{0} / ".format(journal.ledger.name)
        name = name[:-3]
        info['Body'].append(
            {'Date': voucher.date.strftime('%d-%b-%Y'), 'Name': name, 'Url': get_edit_url(request, voucher),
             'Type': VoucherType.by_id(voucher.type).name, 'Narration': voucher.narration, 'Debit': debit,
             'Credit': credit, 'Running': running_total, 'Posted': voucher.posted})

    info['Footer'] = {'Date': finish_date, 'Name': 'Closing Balance', 'Type': 'Closing Balance',
                      'Narration': '', 'Debit': total_debit, 'Credit': total_credit,
                      'Running': running_total, 'Posted': True}


def opening_balance(ledgerID, start_date):
    opening = DBSession.query(func.sum(Journal.amount * Journal.debit)) \
        .join(Journal.voucher) \
        .filter(Voucher.date < datetime.datetime.strptime(start_date, '%d-%b-%Y')) \
        .filter(Voucher.type != VoucherType.by_name('Issue').id) \
        .filter(Journal.ledger_id == ledgerID) \
        .scalar()
    opening = 0 if opening is None else opening
    if opening < 0:
        credit = opening * -1
        debit = 0
    else:
        debit = opening
        credit = 0
    return 0, 0, opening, {'Date': start_date, 'Name': 'Opening Balance', 'Type': 'Opening Balance',
                           'Narration': '', 'Debit': debit, 'Credit': credit, 'Running': opening, 'Posted': True}


